/***************************************************************************
 *   Copyright (C) 2004 by dsievers@NIVIDA                                 
 *                                                               
 ***************************************************************************/

#ifndef _VWR_H_
#define _VWR_H_

#include <wx/docview.h>
#include "vwrview.h"

/**
 * @short Application Main Window
 * @author dsievers,,, <dsievers@de-dsievers-linux>
 * @version 0.1
 */
class wxDocManager;
class VwrFrame;

class VwrApp;

extern VwrApp* theApp;

class VwrApp : public wxApp
{
  public:
    VwrApp();
    virtual ~VwrApp();

    virtual bool OnInit();
    virtual int OnExit(void);
    
    VwrFrame* GetFrame() { return m_frame; };  
    
  protected:	
   wxDocManager* m_docManager;
   VwrFrame* m_frame;
};

class VwrFrame : public wxDocParentFrame
{
  DECLARE_CLASS(VwrFrame)
  public:
    VwrFrame(wxDocManager *manager, wxFrame *frame, wxWindowID id, const wxString& title, const wxPoint& pos, const wxSize& size,
           const long type);
    void OnQuit( wxCommandEvent& event );  
    void OnAbout( wxCommandEvent& event );
    void OnCloseWindow( wxCloseEvent& event );
    void OnSetRotationPoint(wxCommandEvent& event );
    void OnViewAll(wxCommandEvent& event );
    void enableMenuNavigation( bool enable=true );

    void setCurrentView( VwrView* view ) { m_currentView=view; }

  protected:
    wxMenu* m_menuFile;
    wxMenu* m_menuNav;
    VwrView* m_currentView;

  DECLARE_EVENT_TABLE()
};

enum
{
  Menu_File_Quit = 100,
  Menu_File_About
};

#endif // _VWR_H_
