/***************************************************************************
 *   Copyright (C) 2004 by dsievers@NIVIDA                                 
 *                                                               
 ***************************************************************************/
#ifndef VWRDOCUMENT_H
#define VWRDOCUMENT_H

#include <wx/docview.h>

#include "nvsg/nvsgapi.h"
#include "nvsg/Scene.h"
#include "nvsg/ViewState.h"

class nvsg::Node;


/**
@author dsievers,,,
*/
class VwrDocument : public wxDocument
{
   DECLARE_DYNAMIC_CLASS(VwrDocument)
public:
    VwrDocument();
    ~VwrDocument();
        
    virtual bool OnCloseDocument();
    virtual bool OnOpenDocument(const wxString& filename);
    virtual bool OnSaveDocument(const wxString& filename);
    virtual bool DeleteContents();
    virtual bool OnCreate(const wxString& path, long flags);

    const nvsg::Scene     * getScene( void )            const { return( m_pScene ); }
    const nvsg::ViewState * getInitialViewState( void ) const { return( m_pViewState); } 
    
protected:
    const nvsg::Scene* m_pScene;    
    nvsg::Node * createSimpleTree() const;
    const nvsg::ViewState* m_pViewState;
};

#endif
